package com.loafle.overflow.module.auth.service;

import com.loafle.overflow.module.auth.dao.AuthCrawlerDAO;
import com.loafle.overflow.module.auth.model.AuthCrawler;
import com.loafle.overflow.module.infra.model.Infra;
import com.loafle.overflow.module.infra.service.InfraService;
import com.loafle.overflow.module.meta.model.MetaCrawler;
import com.loafle.overflow.module.target.model.Target;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Created by snoop on 17. 8. 30.
 */
@Service("AuthCrawlerService")
public class AuthCrawlerService {

    @Autowired
    private AuthCrawlerDAO authCrawlerDAO;

    @Autowired
    private InfraService infraService;

    public AuthCrawler regist(AuthCrawler authCrawler) {

        AuthCrawler dbAuthCrawler = this.authCrawlerDAO.findByCrawlerAndTarget(authCrawler.getCrawler(), authCrawler.getTarget());

        if(authCrawler == null) {
            return this.authCrawlerDAO.save(authCrawler);
        }

        dbAuthCrawler.setAuthJson(authCrawler.getAuthJson());
        dbAuthCrawler.setCrawler(authCrawler.getCrawler());
        dbAuthCrawler.setTarget(authCrawler.getTarget());

        return this.authCrawlerDAO.save(dbAuthCrawler);
    }

    public boolean checkAuthCrawler(long infraId, MetaCrawler crawler, String authJson) {

        Infra infra = this.infraService.read(infraId);

        // FIXME: Check Crawler on Probe

        return false;
    }

    public AuthCrawler readAuth(MetaCrawler metaCrawler, Target target) {

        return this.authCrawlerDAO.findByCrawlerAndTarget(metaCrawler, target);
    }

}
