package com.loafle.overflow.module.infra.dao;

import com.loafle.overflow.module.infra.model.Infra;
import com.loafle.overflow.module.probe.model.Probe;
import com.loafle.overflow.module.target.model.Target;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created by insanity on 17. 6. 23.
 */
@Repository
public interface InfraDAO extends JpaRepository<Infra, Long> {
    List<Infra> findAllByProbe(Probe probe);

    Page<Infra> findAllByProbe(Probe probe, Pageable pageable);

    @Query("SELECT i FROM INFRA i WHERE i.probe IN (:probeList) AND i.target != NULL")
    Page<Infra> findAllByProbeList(@Param("probeList") List<Probe> probeList, Pageable pageable);


    @Query("SELECT DISTINCT i.target FROM INFRA i WHERE i.probe IN (:probeList)")
    List<Target> findAllTargetByProbeList(@Param("probeList") List<Probe> probeList);

    Infra findByTarget(Target target);

//    List<Infra> findAllByProbe(List<Probe> probeList);
}