package com.loafle.overflow.module.sensor.service;

import com.loafle.overflow.commons.model.PageParams;
import com.loafle.overflow.commons.utils.PageUtil;
import com.loafle.overflow.module.sensor.dao.SensorItemDAO;
import com.loafle.overflow.module.sensor.model.Sensor;
import com.loafle.overflow.module.sensor.model.SensorItem;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by insanity on 17. 6. 28.
 */
@Service("SensorItemService")
public class SensorItemService {

    @Autowired
    private SensorItemDAO sensorItemDAO;

    public SensorItem regist(SensorItem sensorItem) {
        return this.sensorItemDAO.save(sensorItem);
    }

    public boolean registAll(List<SensorItem> sensorItemList) {this.sensorItemDAO.save(sensorItemList);
    return true;
    }

    public SensorItem read(String id) {
        return this.sensorItemDAO.findOne(Long.valueOf(id));
    }

    public Page<SensorItem> readAllBySensor(Sensor sensor, PageParams pageParams) {
        return this.sensorItemDAO.findAllBySensor(sensor, PageUtil.getPageRequest(pageParams));
    }

    public void remove(SensorItem sensorItem) {
        this.sensorItemDAO.delete(sensorItem);
    }
}
