package com.loafle.overflow.proxy;

import com.loafle.overflow.commons.model.SessionMetadata;
import io.grpc.*;

public class ProxyServerInterceptor implements ServerInterceptor {

    @Override
    public <ReqT, RespT> ServerCall.Listener<ReqT> interceptCall(ServerCall<ReqT, RespT> call, Metadata headers, ServerCallHandler<ReqT, RespT> next) {
        String email = headers.get(SessionMetadata.METADATA_EMAIL_KEY);
        Context ctx = Context.current().withValue(SessionMetadata.CTX_EMAIL_KEY, email);

        return Contexts.interceptCall(ctx, call, headers, next);
    }
}
